
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JavaScript原型链和instanceof运算符的暧昧关系 / iVAN</title>

    <meta name="description" content="JavaScript原型链和instanceof运算符的暧昧关系 时间回到两个月前,简单地理了理原型链.prototype以及__proto__之间的乱七八糟的关系,同时也简单了解了下typeof和instanceof两个运算符,但是,anyway,试试以下两题: console.log(Function instanceof Function); console.log(String instanceof String); 如果无法得出准确答案,跟着楼主一起温故而知新吧. 温故 我们经常用typeof运算符来判断一个变量的类型,也确实挺好用,能判断出numb">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JavaScript原型链和instanceof运算符的暧昧关系</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>时间回到两个月前，简单地理了理原型链、prototype以及__proto__之间的乱七八糟的关系，同时也简单了解了下typeof和instanceof两个运算符，但是，anyway，试试以下两题：</p>
<p>console.log(Function instanceof Function);<br />
console.log(String instanceof String);</p>
<p>如果无法得出准确答案，跟着楼主一起温故而知新吧。</p>
<p><strong>温故</strong></p>
<p>我们经常用typeof运算符来判断一个变量的类型，也确实挺好用，能判断出number、boolean、string，但是对于<br />
object的判断能力一般，比如Array和null的判断结果都是object，而且对于new的一些对象，比如new String()，new<br />
Number()等的结果都是object，这样下来就有个问题，无法更细致地判断对象实例，这时就需要instanceof出马了。顾名思<br />
义，instanceof是判断一个对象是否为某一构造函数实例的运算符，这样下来，对于new出来的变量，到底是number、string还是别的什<br />
 么玩意，就有了进一步的判断认识了。看起来很简单，其实不然，上面的两题就是小试牛刀了，先放着，再来回顾下原型链。</p>
<p>JavaScript中一切皆为对象，所有对象都有个__proto__属性值（即原型），可能某些坑爹浏览器下不支持，暂且不管，某对象的该<br />
属性的取值是该对象的构造函数的prototype值，作用就是对于某一个类型的对象，不用重复定义某种方法，譬如说对于对象[1,2,3]，显然这是个</p>
<p>数组对象，它具有pop、push等方法，但是并不是说它本身就具有这些方法，而是它的构造函数Array函数所具有，而该对象的__proto__取值</p>
<p>就是Array函数的prototype值，so如果本身并不具有pop方法，就会从它的__proto__中寻找，即所谓的原型链；而该条链的末端就是<br />
 Object，因为一切对象都是由Object构造而成，而Object.prototype.__proto__规定指向null。</p>
<p>文字的描述永远是苍白无力的，举个简单的例子：</p>
<pre>
</pre>
<ol>
<li>var fun = function(){ </li>
<li>  this.a = 1; </li>
<li>}; </li>
<li>  </li>
<li>fun.prototype.b = 2; </li>
<li>var obj = new fun(); </li>
<li>obj.a; //1 </li>
<li>obj.b; //2</li>
</ol>
<p><a href="http://s4.51cto.com/wyfs02/M02/6E/31/wKioL1V2WEzxrvG-AAAdd3IhRMI834.png-wh_651x-s_1262345575.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDIvNkUvMzEvd0tpb0wxVjJXRXp4cnZHLUFBQWRkM0loUk1JODM0LnBuZy13aF82NTF4LXNfMTI2MjM0NTU3NS5wbmc=.jpg"></a></p>
<p>网上盗的例子和图，仔细看就会发现说的很清楚。</p>
<p><strong>知新</strong></p>
<p>接下来看看instanceof运算符。</p>
<p>instanceof的常规用法是判断a是否是b类型：</p>
<pre>
</pre>
<ol>
<li>console.log(true instanceof Boolean); // false  </li>
<li>console.log(new Number(1) instanceof Number); // true </li>
</ol>
<p>instanceof还能判断父类型：</p>
<pre>
</pre>
<ol>
<li>function Father() {} function Child() {} Child.prototype = new Father(); var a = new Child(); console.log(a instanceof Child);  // true </li>
<li>console.log(a instanceof Father); // true </li>
</ol>
<p>Child构造函数继承自Father，实例a是Child构造的无疑，但是为何也是Father的实例呢？其实instanceof运算符的内核可以简单地用以下代码描述：</p>
<pre>
</pre>
<ol>
<li>function check(a, b) {   while(a.__proto__) {     if(a.__proto__ === b.prototype)       return true;     a = a.__proto__;   }   return false; } function Foo() {} console.log(Object instanceof Object === check(Object, Object)); // true </li>
<li>console.log(Function instanceof Function === check(Function, Function)); // true </li>
<li>console.log(Number instanceof Number === check(Number, Number)); // true </li>
<li>console.log(String instanceof String === check(String, String)); // true </li>
<li>console.log(Function instanceof Object === check(Function, Object)); // true </li>
<li>console.log(Foo instanceof Function === check(Foo, Function)); // true </li>
<li>console.log(Foo instanceof Foo === check(Foo, Foo)); // true </li>
</ol>
<p>简单地说，a如果是b的实例，那么a肯定能使用b的prototype中定义的方法和属性，那么用代码表示就是a的原型链中有b.prototype取值相同的对象，于是顺着a的原型链一层层找就行了。</p>
<p>另外值得注意的是，String Number Boolean 以及Function等都是函数，而函数则是统一由Function构造而来的，so它们和任何单纯的函数一样，能用Function上的原型属性：</p>
<pre>
</pre>
<ol>
<li>Function.prototype.a = 10; console.log(String.a);  // 10 </li>
</ol>
<p>最后来简单讲讲最开始的两道题吧。</p>
<pre>
</pre>
<ol>
<li>// 为了方便表述，首先区分左侧表达式和右侧表达式 </li>
<li>FunctionL = Function, FunctionR = Function; // 下面根据规范逐步推演 </li>
<li>O = FunctionR.prototype = Function.prototype L = FunctionL.__proto__ = Function.prototype // 第一次判断 </li>
<li>O == L // 返回 true</li>
</ol>
<pre>
</pre>
<ol>
<li>// 为了方便表述，首先区分左侧表达式和右侧表达式 </li>
<li>StringL = String, StringR = String; // 下面根据规范逐步推演 </li>
<li>O = StringR.prototype = String.prototype L = StringL.__proto__ = Function.prototype // 第一次判断 </li>
<li>O != L // 循环再次查找 L 是否还有 __proto__ </li>
<li>L = String.prototype.__proto__ = Object.prototype // 第二次判断 </li>
<li>O != L // 再次循环查找 L 是否还有 __proto__ </li>
<li>L = String.prototype.__proto__ = null </li>
<li>// 第三次判断 </li>
<li>L == null </li>
<li>// 返回 false </li>
</ol>
<p>作者：韩子迟</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:31:24</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>, <a href="https://www.iamivan.net/tag/prototype/" title="prototype">prototype</a>, <a href="https://www.iamivan.net/tag/log/" title="LOG">LOG</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JavaScript原型链和instanceof运算符的暧昧关系的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5oZ46b.html" rel="bookmark">JavaScript原型链示例分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 这篇文章主要介绍了JavaScript原型链示例,有需要的朋友可以参考一下    代码如下: &lt;mce:script type=&quot;text/javascript&quot;&gt;&lt;!-- /*    每个对象实例都有个属性成员用于指向到它的instanceof 对象(暂称为父对象)的原型(prototype)    我们把这种层层指向父原型的关系称为[原型链 prototype chian]    原型也具有父原型,因为它往往也是一个对象实例,除非我们人为地去改变它    在Ja			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJwYdvb.html" rel="bookmark">Javascript原型链的原理详解&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例分析了Javascript原型链的原理.分享给大家供大家参考,具体如下: 一.JavaScript原型链 ECMAScript中描述了原型链的概念,并将原型链作为实现继承的主要方法.其基本思想是利用原型让一个引用类型继承另一个引用类型的属性和方法.在JavaScript中,用 __proto__ 属性来表示一个对象的原型链.当查找一个对象的属性时,JavaScript 会向上遍历原型链,直到找到给定名称的属性为止! 比如现在有如下的代码: 扩展Object类,添加Clone和Extend			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M621lNM.html" rel="bookmark">深入浅出理解javaScript原型链</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了对javaScript原型链的理解,以实例形式对javaScript原型链的概念及相关使用技巧做了较为浅显易懂的分析,需要的朋友可以参考下 本文实例讲述了javaScript的原型链.分享给大家供大家参考.具体分析如下: 对于javascript原型链,以前都觉得是个很深的东西,一直没有理解很明白,今天看了一些介绍后,发现这张图,表示再没有什么语言能比这张图说得清楚了. 看了这张图后突然对javascript有了质的理解. javascript的原型链有显式和隐式两种: 显			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0xLOp.html" rel="bookmark">深入理解javascript原型链和继承&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上一篇文章中,介绍了原型的概念,了解到在javascript中构造函数.原型对象.实例三个好基友之间的关系:每一个构造函数都有一个&quot;守护神&quot;--原型对象,原型对象心里面也存着一个构造函数的&quot;位置&quot;,两情相悦,而实例呢却又&quot;暗恋&quot;着原型对象,她也在心里留存了一个原型对象的位置. javascript本身不是面向对象的语言,而是基于对象的语言,对于习惯了其他OO语言的人来说,起初有些不适应,因为在这里没有&quot;类&quot;的概念,或者说&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ27vOz.html" rel="bookmark">理解JavaScript原型链&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				每一个JavaScript对象都和另一个对象相关联,相关联的这个对象就是我们所说的&quot;原型&quot;.每一个对象都会从原型继承属性和方法.有一个特殊的对象没有原型,就是Object.在之后的图示中会进行说明. 举个栗子,我们首先声明一个函数Student(): function Student(name){ this.name = name; this.hello = function(){ alert(`Hello,${this.name}`); } } 这个函数包含一个属性name和一个方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqZ3Op.html" rel="bookmark">深入浅出理解javaScript原型链&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了javaScript的原型链.分享给大家供大家参考.具体分析如下: 对于javascript原型链,以前都觉得是个很深的东西,一直没有理解很明白,今天看了一些介绍后,发现这张图,表示再没有什么语言能比这张图说得清楚了. 看了这张图后突然对javascript有了质的理解. javascript的原型链有显式和隐式两种: 显式原型链:即我们常见的prototype: 隐式原型链:在一般环境下无法访问,即不可见,在FireFox下可以通过__proto__方式访问:隐式原型链用于jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zw5jYWM.html" rel="bookmark">浅谈javascript原型链与继承&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js原型链与继承是js中的重点,所以我们通过以下三个例子来进行详细的讲解.       首先定义一个对象obj,该对象的原型为obj._proto_,我们可以用ES5中的getPrototypeOf这一方法来查询obj的原型,我们通过判断obj的原型是否与Object.prototype相等来证明是否存在obj的原型,答案返回true,所以存在.然后我们定义一个函数foo(),任何一个函数都有它的prototype对象,即函数的原型,我们可以在函数的原型上添加任意属性,之后通过new一个实例化的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXWoOyM.html" rel="bookmark">关于JavaScript 原型链的一点个人理解&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript借鉴了许多语言的特点:例如语法类Java.函数借鉴Scheme.原型继承借鉴自Self.正则表达式借鉴于Perl.(DC Javascript:语言精粹).      首先,每个JS是一门基于原型继承的面向对象的语言.里面数组是对象.函数是对象.&quot;对象&quot;当然还是对象.而且每个对象都有一个internal slot[[prototype]],这才是原型链连接起来的关键.诚然,我们可以为一个对象设置prototype property,但这又怎么样呢,这只是表象:后面暗			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOnY0vp.html" rel="bookmark">JavaScript原型链示例分享&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				复制代码 代码如下: &lt;mce:script type=&quot;text/javascript&quot;&gt;&lt;!--/*   每个对象实例都有个属性成员用于指向到它的instanceof 对象(暂称为父对象)的原型(prototype)   我们把这种层层指向父原型的关系称为[原型链 prototype chian]   原型也具有父原型,因为它往往也是一个对象实例,除非我们人为地去改变它   在JavaScript中,&quot;一切都是对象,函数是第一型.&quot;   Fun			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKr0Zz.html" rel="bookmark" class="title">用户研究&colon;如何研究90后网民形态</a>
					<div>
						上篇文章一经发表(90后的用户形态研究),受到了很大的关注.今天群里一位华为的同学提意见说,&quot;分析的过程是有帮助的,不过感觉不够深入&quot;.于是有了这篇90后用户形态研究(第二期).这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bor33z.html" rel="bookmark" class="title">java io学习（八） FileDescriptor总结</a>
					<div>
						本章对FileDescriptor进行介绍 FileDescriptor 介绍 FileDescriptor 是&quot;文件描述符&quot;. FileDescriptor 可以被用来表示开放文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK77l5b.html" rel="bookmark" class="title">ASP&period;NET AJAX入门系列（11）：在多个UpdatePanle中使用Timer控件</a>
					<div>
						本文将使用Timer控件更新两个UpdatePanel控件,Timer控件将放在UpdatePanel控件的外面,并将它配置为UpdatePanel的触发器,翻译自官方文档. 1．添加一个新页面并切换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOwXx3z.html" rel="bookmark" class="title">在虚拟主机上复制安装本机Pear</a>
					<div>
						在国内租来的虚拟主机上,有部分主机本身就提供了pear类库,但是不用指望它们会给你升级或安装需要的pear包.在这种情况下,可以尝试在自己的虚拟主机下安装一份pear. 通过ssh安装pear 国内绝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4elwp.html" rel="bookmark" class="title">Win7系统本地连接被禁用了怎么办？</a>
					<div>
						  Win7系统本地连接被禁用了怎么办?         方法一: 1.在桌面上的&quot;网络&quot;单击右键,选择&quot;属性&quot;; 2.在左侧点击&quot;更改适配器设置&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AnP6p.html" rel="bookmark" class="title">实现获取http内容的php函数分享</a>
					<div>
						 这篇文章主要介绍了实现获取http内容的php函数,现在分享给大家,需要的朋友可以看一下  代码如下: &lt;?php function http_open($url, $data, $cooki ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKZEoM.html" rel="bookmark" class="title">wmv用什么播放器播放？</a>
					<div>
						wmv用什么播放器播放?   wmv文件 wmv文件介绍: WMV文件一般同时包含视频和音频部分.视频部分使用Windows Media Video编码,音频部分使用Windows Media Aud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL95Ob.html" rel="bookmark" class="title">google earth打不开怎么办</a>
					<div>
						  Google Earth打不开不是软件本身的问题,而是国情所至,以前,Google在国内时,情况还好,自从搬到HK去以后,时不时的都要出点问题,就象这些天,又出现了打不开的情况,解决方法如下: 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGPKAp.html" rel="bookmark" class="title">迅雷7一直不断重启这是什么原因？</a>
					<div>
						  [1]建议卸载原来的迅雷,至http://dl.xunlei.com 这个页面下载迅雷7最新版本安装包, 重新安装在另外一个磁盘上尝试.(请不要覆盖安装,必须卸载重新安装,不然可能会覆盖上旧问题) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ7mVz.html" rel="bookmark" class="title">Chrome下ifame父窗口调用子窗口的问题示例探讨&lowbar;javascript技巧</a>
					<div>
						项目中遇到的一个浏览器不兼容问题: 在IE和Firefox下直接在ifame框架页的父窗口用子窗口的name调用子窗口的js函数都好使,在Chrome下不好使. 复制代码 代码如下: &lt;fram ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Bnlz.html" rel="bookmark" class="title">C&plus;&plus; 用libcurl库进行http通讯网络编程</a>
					<div>
						目录索引: 一.LibCurl基本编程框架 二.一些基本的函数 三.curl_easy_setopt函数部分选项介绍 四.curl_easy_perform 函数说明(error 状态码) 五.lib ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQWaOp.html" rel="bookmark" class="title">JAVAONE 2016会议总结</a>
					<div>
						有幸获得阿里赞助,前去旧金山参加Oracle举办的JAVAONE 2016开发者大会,JAVAONE作为Java界最顶级的盛会,会议内容将展现出数千万开发者最关心的问题,以及java的未来发展方向.大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kQ2oM.html" rel="bookmark" class="title">大学生应聘者面试遇怪题时怎么办？</a>
					<div>
						阿兵(化名)今年大学毕业,学的专业是软件编程与应用.前些天他去合肥市庐阳区一家企业应聘程序员,一轮面试下来,前面几个专业问题感觉还不错,不料最后一题面试官抛出:&quot;怎么知道合肥有多少猫和老鼠? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQON5z.html" rel="bookmark" class="title">关于oauth认证中的签名算法HMAX-SHA1的使用</a>
					<div>
						问题描述 最近正在做与新浪网的资源共享方面的东西.在使用新浪微博帐号登录我网站时候是要通过oauth认证.里面有一项就是需要一个签名.而且签名的方法必须是HMAC-SHA1的.现在很迷糊这个HMAC- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEZLvM.html" rel="bookmark" class="title">spring data jpa的误将方法名当成属性名称的问题</a>
					<div>
						问题描述 项目中使用了spring data jpa,自己扩展了一个全局接口AbstractJxetRepositorypublic interface AbstractJxetRepository& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWnmRz.html" rel="bookmark" class="title">大神们，我的yum不能用了，这是怎么回事啊，帮忙解决下？</a>
					<div>
						问题描述 大神们,我的yum不能用了,这是怎么回事啊,帮忙解决下? 10C yum listyum search gccyum install gcc等这些设计yum的命令都会出现问题:Could n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlqYnp.html" rel="bookmark" class="title">JavaScript 基本数据类型和引用类型的区别详解</a>
					<div>
						前两天看到kraaas大神的关于基本数据类型和引用类型的区别的文章觉得写得非常不错,就想着在其基础上加上自己平时看到的一些知识点和理解,所以就有了以下的文章 js基本数据类型: js基本数据类型包括: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRON3b.html" rel="bookmark" class="title">linux partprobe命令</a>
					<div>
						linux上,在安装系统之后,可否创建分区并且在不重新启动机器的情况下系统能够识别这些分区? 解决方法: 你可以使用一个叫做partprobe的工具.它包含在parted的rpm软件包中.在Red H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKQ4kz.html" rel="bookmark" class="title">Flink原理与实现：Window的实现原理</a>
					<div>
						Flink原理与实现系列文章: Flink 原理与实现:架构和拓扑概览Flink 原理与实现:如何生成 StreamGraphFlink 原理与实现:如何生成 JobGraphFlink原理与实现:如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgqk4b.html" rel="bookmark" class="title">做SEO这个行业的人越来越多，竞争何止是激烈二词可以来形容的</a>
					<div>
						做SEO这个行业的人越来越多,竞争何止是激烈二词可以来形容的,我们面临的问题有很多,比如该怎么提高自己的创新思维.如何去完善网站.如何整理资源等等问题都是我们做优化人员需要掌握和了解的.那么,优化公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwQgAM.html" rel="bookmark" class="title">《UNIX网络编程 卷2：进程间通信（第2版）》&mdash;&mdash;1&period;3　IPC对象的持续性</a>
					<div>
						1.3 IPC对象的持续性 我们可以把任意类型的IPC的持续性(persistence)定义成该类型的一个对象一直存在多长时间.图1-2展示了三种类型的持续性. (1)随进程持续的(process-p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnJoAM.html" rel="bookmark" class="title">html5-select下拉框没有数据</a>
					<div>
						问题描述 select下拉框没有数据 后台代码 public String toList() { BuildingQuery q = (BuildingQuery) getContext().getS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWJAeM.html" rel="bookmark" class="title">巴拉现身或将参与发布会</a>
					<div>
						刚刚宣布加盟小米公司的谷歌前高管雨果·巴拉(Hugo Barra),于今日下午现身了小米公司的总部.据小米公司CEO雷军确认称,巴拉将参与小米9月5日的年度发布会活动.多名小米公司员工透露,巴拉刚刚抵 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodgkBM.html" rel="bookmark" class="title">grep 命令系列：grep 中的正则表达式</a>
					<div>
						grep 命令系列:grep 中的正则表达式 在 Linux .类 Unix 系统中我该如何使用 Grep 命令的正则表达式呢? Linux 附带有 GNU grep 命令工具,它支持扩展正则表达式e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwnjWM.html" rel="bookmark" class="title">中国的私有云IaaS建设之路</a>
					<div>
						和掣肘重重的公有云IaaS(基础设施即服务)建设相比,基于私有云部署方式的IaaS建设有着更加自由的成长空间.在中国特色的市场环境中,后者正在领先一步收获成功. 云计算在中国这片土地上所掀起的浪潮越来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7wAAM.html" rel="bookmark" class="title">Android的OkHttp包中的HTTP拦截器Interceptor用法示例&lowbar;Android</a>
					<div>
						OkHttp(GitHub:https://github.com/square/okhttp) 的 Interceptor 就如同名称「拦截器」一样,拦截你的 Request 做一些你想做的事情再送出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7QgkAM.html" rel="bookmark" class="title">mysql中将null值转换为0的语句&lowbar;Mysql</a>
					<div>
						复制代码 代码如下: SELECT IF(AVG(cai.conversionsRate) IS NULL,0,AVG(cai.conversionsRate)) AS conversionsRate ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrO16p.html" rel="bookmark" class="title">站长必看：蔡文胜5G谈域名秘籍与站长大法&lowbar;网站运营</a>
					<div>
						265.com总裁蔡文胜在5G第一次向业界谈论了他的域名和站长生涯,蔡文胜谈到了hao123和265的起源.中国个人站长的历史进程.将FM365送回联想.265被百度列为黑名单,并真实地回应了诸多问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NvEjz.html" rel="bookmark" class="title">虚拟机-求问VM如何克隆保存到U盘</a>
					<div>
						问题描述 求问VM如何克隆保存到U盘 最近因为变故,要把VM里的虚拟机克隆出来,但是因为之前clone&amp;link过一个虚拟机, 总是显示失败 one of the parmeters supp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgExQ5z.html" rel="bookmark" class="title">csharp-listbox插入按钮的问题</a>
					<div>
						问题描述 listbox插入按钮的问题 c#想在listbox的item中,每一行后面都插入两个按钮 看很多朋友没有理解我的想法,附图 解决方案 listbox没有这个功能,你有两个办法,一个是用da ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
